#ifndef __UFISC_H
#define __UFISC_H


#ifdef UFISC_EXPORTS
	#define UFIS __declspec( dllexport ) 
#else
	#ifdef UFISC_IMPORTS
		#define UFIS __declspec( dllimport )
	#else
		#define UFIS
	#endif
#endif


#define TYPESCANNER_UFIS100		100
#define TYPESCANNER_UFIS110		110
#define TYPESCANNER_UFIS111		111
#define TYPESCANNER_UFIS112		112
#define TYPESCANNER_UFIS210		210
#define TYPESCANNER_UFIS310		310


#define	rcOK							0
#define	rcFINGER_NOT_PRESENT			1	

#define	rcERROR_OPEN_USBDEVICE			-2
#define	rcERROR_CLOSE_USBDEVICE			-3
#define	rcERROR_READ_USBDEVICE			-4
#define	rcERROR_WRITE_USBDEVICE			-5
#define	rcERROR_MEMORY_ALLOCATION		-6	
#define rcERROR_CARD_NOT_FOUND			-7
#define rcERROR_CARD_TYPE				-8
#define rcERROR_WRITECARD				-9
#define rcERROR_CARDDRIVER_NOT_PRESENTS	-10
#define	rcERROR_MUTEX_USBDEVICE			-11

#define	LED_YELLOW_ON	0xF7
#define	LED_GREEN_ON	(0xEF & LED_YELLOW_ON)
#define	LED_RED_ON	(0xDF & LED_YELLOW_ON)

#define	LED_OFF		0xFF
#define	LED_GREEN_OFF	(0xFF & LED_YELLOW_ON)
#define	LED_RED_OFF	(0xFF & LED_YELLOW_ON)


#pragma pack(push, 1)


#ifdef __cplusplus
extern "C" 
{
#endif


extern int	UFIS ufisStartup(void);
extern int	UFIS ufisCleanup(void);

extern int	UFIS ufisOpenDeviceT(int type_scanner, unsigned long ID);
extern int	UFIS ufisOpenDevice(unsigned long ID);


extern int	UFIS ufisCloseDevice(int handle);
extern int	UFIS ufisCloseAllDevices(void);
extern void	UFIS ufisSetTimeoutOpenDevice(int msec);

extern unsigned long UFIS ufisGetDeviceID(int handle);

extern int	UFIS ufisIsOpenDevice(int handle, unsigned long ID);
extern int	UFIS ufisWhatOpened(int handle);

extern int	UFIS ufisStartupSensor(int handle);
extern int	UFIS ufisIsFingerPresent(int handle);
extern void	UFIS ufisSetTimeoutIsFingerPresent(int msec);

extern unsigned char UFIS *  ufisGetImage(int handle);
extern unsigned char UFIS *  ufisGetImageBuffer(int handle);
extern int	UFIS ufisGetImageToBuf(int handle, unsigned char * img);
extern int	UFIS ufisGetImageParam(int handle);
extern int	UFIS ufisGetQualityImage(int handle, unsigned char * img);

extern int	UFIS ufisReset(int handle);

extern unsigned char UFIS *  ufisConvertToBmp24(int handle);
extern int	UFIS ufisGetLengthBmp24(int handle);

extern unsigned char UFIS *  ufisConvertToBmp8(int handle);
extern int	UFIS ufisGetLengthBmp8(int handle);


extern int	UFIS ufisGetHeight(int handle);
extern int	UFIS ufisGetWidth(int handle);
extern int	UFIS ufisGetLength(int handle);
extern void UFIS ufisSetPressureLevel(int handle, int startLevel);
extern void UFIS ufisSetThreshold(int handle, int threshold);


extern int	UFIS ufisControlLED(int handle, unsigned char set);
extern void	UFIS ufisFlashLED(int handle, int type, int msec);

extern unsigned char UFIS *  ufisGetVersion(void);

extern	int	UFIS ufisReadFromMem(int	handle, unsigned char * Buf);
extern	int	UFIS ufisWriteToMem(int handle, unsigned char * Buf, short length);

int	ufisStartupReal(void);
int	ufisCleanupReal(void);

extern int	UFIS ufisInfoUFIS111(int handle, unsigned char lT, unsigned char hT, short * temperature, unsigned char * tPlus, int flag);
extern void	UFIS ufisGetxTUFIS111(int handle, unsigned char * lT, unsigned char * hT);
extern void	UFIS ufisSetxTUFIS111(int handle, unsigned char lT, unsigned char hT);

#ifdef __cplusplus
}
#endif


#pragma pack(pop)

#endif

